<script>
import { useAuthStore } from '../stores/auth.store';
import { useFieldsDataStore } from '../stores/fields_data.store';
import { useLayoutIDStore } from '../stores/layout_id.store';
import { useLastSignatureStore } from '../stores/last_signature.store';

const baseUrl = `${import.meta.env.VITE_API_URL}`;

export default {
    data() {
        return {
            authStored: useAuthStore(),
            fieldsStored: useFieldsDataStore(),
            layIDStored: useLayoutIDStore(),
            lastSigStored: useLastSignatureStore(),
            localErros: []
        };
    },
    methods: {
        async updateUserData() {
            const userID = this.authStored.user.id;
            await this.$axios
                .get(`${baseUrl}/users/${userID}`)
                .then((user_resp) => this.authStored.login(user_resp.data));
        },
        async createSignature() {
            const userID = this.authStored.user.id;
            const layoutObj = { layout_id: this.layIDStored.layout_id };
            const fields = this.fieldsStored.fields_data;

            const reqObj = { ...fields, ...layoutObj };

            await this.$axios
                .post(`${baseUrl}/users/${userID}/signatures/`, {
                    ...reqObj
                })
                .then((resp) => this.lastSigStored.update(resp.data))
                .catch((error) => {
                    if (error.response.status == 400) {
                        this.localErros = error.response.data.errors;
                    }
                });

            this.updateUserData();
        }
    }
};
</script>

<template>
    <el-button @click="createSignature()">Create</el-button>
</template>
